from selenium import webdriver
from selenium.webdriver.common.by import By
from selenium.webdriver.common.keys import Keys
from selenium.webdriver.chrome.service import Service
from webdriver_manager.chrome import ChromeDriverManager
import time
import json
import os


def login_to_tistory(driver, username, password):
    driver.get("https://www.tistory.com/auth/login")
    
    time.sleep(2)
    
    # 아이디 입력
    driver.find_element(By.NAME, "loginId").send_keys(username)
    time.sleep(1)
    
    # 비밀번호 입력
    driver.find_element(By.NAME, "password").send_keys(password)
    time.sleep(1)
    
    # 로그인 버튼 클릭
    driver.find_element(By.CLASS_NAME, "btn_login").click()
    
    time.sleep(5)  # 로그인 후 페이지 로딩 대기

def post_review(driver, review):
    driver.get("https://www.tistory.com/manage/posts/post")
    
    time.sleep(5)
    
    # 제목 입력
    driver.find_element(By.ID, "postTitle").send_keys(f"{review['username']} 고객 구입후기 - 테크노마트 리얼컴 네이버카페")
    
    time.sleep(1)
    
    # HTML 블록 추가
    driver.find_element(By.CSS_SELECTOR, "button[aria-label='HTML블록']").click()
    time.sleep(1)
    
    # HTML 블록에 내용 입력
    content = f"<pre>{review['content']}</pre>"
    if review['img_path']:
        content += f'<br><img src="{review['img_path']}" />'
    
    # 여기서 HTML 소스를 입력합니다.
    example_source_code = '''
    
       <div>
        <h2>추가 이미지</h2>
        <img src="https://blog.kakaocdn.net/dn/b77SBt/btst6P2OBNx/sMGZZPAuJwH2kyGG2xUq3K/img.jpg" alt="image1">
        <img src="https://blog.kakaocdn.net/dn/BiQbZ/btst6kIDWoL/6LknOSUf2lJYy390UkdrKK/img.jpg" alt="image2">
        <img src="https://blog.kakaocdn.net/dn/JQdjy/btst5QHPwUI/qRlkFLnBKCHLi3kJg7fkE1/img.jpg" alt="image3">
        <p>자세한 정보는 <a href="http://cafe.naver.com/realcom7">여기</a>를 클릭하세요.</p>
    </div>
    
    <div class="se-component se-text se-l-default" id="SE-2a8db1d5-4842-4c15-93c2-dd8b0beef3eb"><div class="se-component-content"><div class="se-section se-section-text se-l-default"><div class="se-module se-module-text"><p class="se-text-paragraph se-text-paragraph-align- " id="SE-7102bcd1-6464-4337-8a89-f23a4560a938"><b><span class="se-fs- se-ff-   " id="SE-6a75ab6e-9018-422f-a089-3344c140ce33" style="font-size: 13.3333px;"></span></b></p><!-- } SE-TEXT --><!-- SE-TEXT { --><p class="se-text-paragraph se-text-paragraph-align- " id="SE-4184e0b4-5b07-4671-8a57-b14f45f3307b" style="text-align: center;" align="center"><b style="font-size: 12pt;"><a href="https://cafe.naver.com/ArticleList.nhn?search.clubid=29274663&amp;search.menuid=1&amp;search.boardtype=L" target="_blank"><img src="https://img1.daumcdn.net/thumb/R1280x0/?scode=mtistory2&fname=https%3A%2F%2Fblog.kakaocdn.net%2Fdn%2FP7HJg%2FbtrX41mvjzy%2F4gkD9xjzMvfFtHMmcKqAzK%2Fimg.jpg" title="c74ecf94b9f0a160e4487a76e8dd6211_135314.jpg" class="js-smart-img"></a></b>&nbsp;</p><p class="se-text-paragraph se-text-paragraph-align- " id="SE-4184e0b4-5b07-4671-8a57-b14f45f3307b" style="text-align: center;" align="center"><b style="color: rgb(255, 0, 0); font-size: 16px;">↑클릭&nbsp;</b></p><p class="se-text-paragraph se-text-paragraph-align- " id="SE-4184e0b4-5b07-4671-8a57-b14f45f3307b" style="text-align: center;" align="center"><b style="color: rgb(255, 0, 0); font-size: 16px;">오프라인매장 리얼컴카페 후기</b>&nbsp;</p><p class="se-text-paragraph se-text-paragraph-align- " id="SE-4184e0b4-5b07-4671-8a57-b14f45f3307b" style="text-align: center;" align="center"><span style="font-size: 16px;"><b><br></b></span></p><p class="se-text-paragraph se-text-paragraph-align- " id="SE-4184e0b4-5b07-4671-8a57-b14f45f3307b" style="text-align: center;" align="center"><span style="font-size: 16px;"><b>네이버카페 이용하시는분은&nbsp;</b></span></p><p class="se-text-paragraph se-text-paragraph-align- " id="SE-4184e0b4-5b07-4671-8a57-b14f45f3307b" style="text-align: center;" align="center"><span style="font-size: 16px;"><b>대부분 매장에 방문하시어 구매하신&nbsp;</b></span></p><p class="se-text-paragraph se-text-paragraph-align- " id="SE-4184e0b4-5b07-4671-8a57-b14f45f3307b" style="text-align: center;" align="center"><b style="font-size: 16px;">분들입니다.&nbsp;</b><span style="font-size: 16px;"><b>클릭하여 들어오시면&nbsp;</b></span></p><p class="se-text-paragraph se-text-paragraph-align- " id="SE-4184e0b4-5b07-4671-8a57-b14f45f3307b" style="text-align: center;" align="center"><span style="font-size: 16px;"><b>후기글&nbsp;</b></span><b style="font-size: 16px;">확인이&nbsp;</b><b style="font-size: 16px;">가능합니다.</b></p><p class="se-text-paragraph se-text-paragraph-align- " id="SE-4184e0b4-5b07-4671-8a57-b14f45f3307b" style="text-align: center;" align="center"><span style="font-size: 12pt;"><b>전화연락이나 카톡으로 견적 요청하시면&nbsp;</b></span></p><p class="se-text-paragraph se-text-paragraph-align- " id="SE-4184e0b4-5b07-4671-8a57-b14f45f3307b" style="text-align: center;" align="center"><span style="font-size: 12pt;"><b>친절하게 안내 도와드리겠습니다.&nbsp;</b></span></p><p class="se-text-paragraph se-text-paragraph-align- " id="SE-4184e0b4-5b07-4671-8a57-b14f45f3307b" style="text-align: center;" align="center"><span style="font-size: 12pt;"><b><a href="https://pf.kakao.com/_ksxbgxb" target="_self"><img src="https://img1.daumcdn.net/thumb/R1280x0/?scode=mtistory2&fname=https%3A%2F%2Fblog.kakaocdn.net%2Fdn%2FbX6mvL%2FbtrX41z3eIB%2FYKZfKuUeG53QwJ1MPcGd7k%2Fimg.jpg" title="6ab9a8a0d4ab13bc8e8f6cc6def0dcd5_140043.jpg" class="js-smart-img"></a><br style="clear:both;"></b></span><span style="font-size: 14pt; color: rgb(255, 0, 0);"><b>&nbsp;↑클릭 - 카톡상담</b>&nbsp;</span></p><p class="se-text-paragraph se-text-paragraph-align- " id="SE-4184e0b4-5b07-4671-8a57-b14f45f3307b" style="text-align: center;" align="center">&nbsp;</p><p class="se-text-paragraph se-text-paragraph-align- " id="SE-4184e0b4-5b07-4671-8a57-b14f45f3307b" style="text-align: center;" align="center">&nbsp;<span style="font-size: 12pt;"><b><br></b></span></p><p class="se-text-paragraph se-text-paragraph-align- " id="SE-4184e0b4-5b07-4671-8a57-b14f45f3307b" style="text-align: center;" align="center">&nbsp;<b><a href="tel:0507-1368-7816"><img src="https://img1.daumcdn.net/thumb/R1280x0/?scode=mtistory2&fname=https%3A%2F%2Fblog.kakaocdn.net%2Fdn%2FbxYebK%2FbtrX41064TC%2FbLrlghAAjXuwK3cYuXJaVk%2Fimg.jpg" title="98d63abd5ce25cf621509aa5ef925cf7_143628.jpg" class="js-smart-img"></a></b></p><div class="btn-item bottom_menu_left"><b><a href="tel:0507-1368-7816"><i class="fa fa-plus" aria-hidden="true" style="float:right;padding:3px;"></i></a>
		</b></div><div style="text-align: center;" align="center"><br></div><div style="text-align: center;" align="center"><b>​</b><span style="font-size: 14pt; color: rgb(255, 0, 0);"><b>↑클릭 - 전화상담</b>&nbsp;</span>&nbsp;<br></div><br><p>&nbsp;</p><p class="se-text-paragraph se-text-paragraph-align- " id="SE-4184e0b4-5b07-4671-8a57-b14f45f3307b" style="text-align: center;" align="center"><span style="font-size: 12pt;"><b>
		<b>통화가능 시간대 : 오전10시~오후7시50분</b></b></span></p><p class="se-text-paragraph se-text-paragraph-align- " id="SE-4184e0b4-5b07-4671-8a57-b14f45f3307b" style="text-align: center;" align="center"><b><span style="font-size: 12pt;"><b>매월 (화요일이 포함된)&nbsp;</b></span></b></p><p class="se-text-paragraph se-text-paragraph-align- " id="SE-4184e0b4-5b07-4671-8a57-b14f45f3307b" style="text-align: center;" align="center"><b><span style="font-size: 12pt;"><b>둘째 넷째주 화요일은 휴무입니다.</b></span></b></p><p class="se-text-paragraph se-text-paragraph-align- " id="SE-4184e0b4-5b07-4671-8a57-b14f45f3307b" style="text-align: center;" align="center"><b><span style="font-size: 12pt;"><b>주말에도 영업하고 있습니다.&nbsp;</b></span></b></p><p class="se-text-paragraph se-text-paragraph-align- " id="SE-4184e0b4-5b07-4671-8a57-b14f45f3307b" style="text-align: center;" align="center"><b><span style="font-size: 12pt;"><b>(토요일,일요일 정상근무)</b></span></b></p><p class="se-text-paragraph se-text-paragraph-align- " id="SE-4184e0b4-5b07-4671-8a57-b14f45f3307b" style="text-align: center;" align="center"><b>&nbsp;</b></p><p class="se-text-paragraph se-text-paragraph-align- " id="SE-4184e0b4-5b07-4671-8a57-b14f45f3307b" style="text-align: center;" align="center"><b><span style="font-size: 13.3333px;"><b><a href="https://talk.naver.com/ct/wc6vtl" target="_blank"><img src="https://img1.daumcdn.net/thumb/R1280x0/?scode=mtistory2&fname=https%3A%2F%2Fblog.kakaocdn.net%2Fdn%2FtfNKh%2FbtrX3qHnMdv%2F1BlvcCjhpu7kQ2SJmApQwK%2Fimg.jpg" title="1662966065975_142102.jpg" class="js-smart-img"></a><br style="clear:both;"></b></span><span style="font-size: 14pt;"><b>&nbsp; &nbsp;<span style="color: rgb(255, 0, 0);">↑클릭 - 네이버 톡톡상담</span></b><span style="color: rgb(255, 0, 0);">&nbsp;</span></span><span style="color: rgb(255, 0, 0);">&nbsp;</span><span style="font-size: 13.3333px;"><b><br></b></span></b></p><p class="se-text-paragraph se-text-paragraph-align- " id="SE-4184e0b4-5b07-4671-8a57-b14f45f3307b" style="text-align: center;" align="center"><b>&nbsp;</b></p></div></div></div></div><div class="se-component se-text se-l-default" id="SE-58d4f702-79e2-4684-80d4-6f58bdeed7fe"><div class="se-component-content"><div class="se-section se-section-text se-l-default"><div class="se-module se-module-text"><!-- } SE-TEXT --><!-- SE-TEXT { --><p class="se-text-paragraph se-text-paragraph-align- " id="SE-f0da5130-6c3c-471b-809d-cb479a9ae17f" style="text-align: center;"><b><span class="se-fs- se-ff-   " id="SE-2cd6e87f-3304-4c68-92f3-f3fb575341ec">​</span></b></p></div></div></div></div>
    '''.format(product="Example Product", rating="5 stars")
    
    # 추가 이미지와 링크를 포함한 소스
    additional_images_and_link = '''
 
    '''

    # HTML 블록에 소스 입력
    html_block = driver.find_element(By.CSS_SELECTOR, "textarea[class*='CodeMirror']")
    html_block.send_keys(content + example_source_code + additional_images_and_link)
    time.sleep(1)
    
    # 태그 입력
    tags = "조립피씨, 정직한판매, 테크노마트조립피씨, 광진구조립피씨, 조립컴퓨터, 컴퓨터수리잘하는곳, 테크노마트조립, 조립피씨전문상담, 테크노마트양심매장, 강변테크노마트조립전문, 테크노마트조립피씨선정리잘하는곳, 컴퓨터조립잘하는곳, 테크노마트카페, 가장전문적이고친절한매장, 테크노마트조립추천, 정직한상담, 테크노마트컴퓨터, 테크노마트네이버카페, 테크노마트조립컴퓨터, 테크노마트조립컴"
    tags_element = driver.find_element(By.NAME, "tags")
    tags_element.send_keys(tags)
    
    time.sleep(1)
    
    # 발행 버튼 클릭
    driver.find_element(By.CLASS_NAME, "btn_publish").click()
    
    time.sleep(5)

def post_reviews_daily():
    with open('config.json', 'r') as config_file:
        config = json.load(config_file)
        tistory_username = config['tistory_username']
        tistory_password = config['tistory_password']
    
    # 기존 리뷰 파일이 없으면 빈 리스트로 시작
    if os.path.exists('reviews.json'):
        with open('reviews.json', 'r', encoding='utf-8') as file:
            reviews = json.load(file)
    else:
        reviews = []

    service = Service(ChromeDriverManager().install())
    driver = webdriver.Chrome(service=service)
    
    try:
        login_to_tistory(driver, tistory_username, tistory_password)
        
        posted_count = 0
        for review in reviews:
            if posted_count >= 2:
                break
            post_review(driver, review)
            posted_count += 1
            time.sleep(10)  # 각 게시글 간 간격을 두기 위해 대기
    finally:
        driver.quit()

    # 게시한 후기를 파일에서 제거하고 다시 저장
    remaining_reviews = reviews[posted_count:]
    save_reviews_to_file(remaining_reviews, 'reviews.json')

def save_reviews_to_file(reviews, filename):
    with open(filename, 'w', encoding='utf-8') as file:
        json.dump(reviews, file, ensure_ascii=False, indent=4)

if __name__ == "__main__":
    post_reviews_daily()
